
/*
*   EPT_SineTool.cpp - Library for the
*   DAC 8 Bit Sine Wave Tool. 
*   created by Earth People Technology Inc. February 6, 2019
*   Released to public domain
*/

#include "Arduino.h"
#include "EPT_SineTool.h"

//Declare a Buffer for storing the Sine Wave
//data values for 8 Bit DAC
int ChannelBuffer1[256] = {0};


void EPT_SineToolInit()
{
   ChannelBuffer1[0] = 128;
   ChannelBuffer1[1] = 131;
   ChannelBuffer1[2] = 134;
   ChannelBuffer1[3] = 137;
   ChannelBuffer1[4] = 141;
   ChannelBuffer1[5] = 144;
   ChannelBuffer1[6] = 147;
   ChannelBuffer1[7] = 150;
   ChannelBuffer1[8] = 153;
   ChannelBuffer1[9] = 156;
   ChannelBuffer1[10] = 159;
   ChannelBuffer1[11] = 162;
   ChannelBuffer1[12] = 165;
   ChannelBuffer1[13] = 168;
   ChannelBuffer1[14] = 171;
   ChannelBuffer1[15] = 174;
   ChannelBuffer1[16] = 177;
   ChannelBuffer1[17] = 180;
   ChannelBuffer1[18] = 183;
   ChannelBuffer1[19] = 186;
   ChannelBuffer1[20] = 189;
   ChannelBuffer1[21] = 191;
   ChannelBuffer1[22] = 194;
   ChannelBuffer1[23] = 197;
   ChannelBuffer1[24] = 199;
   ChannelBuffer1[25] = 202;
   ChannelBuffer1[26] = 204;
   ChannelBuffer1[27] = 207;
   ChannelBuffer1[28] = 209;
   ChannelBuffer1[29] = 212;
   ChannelBuffer1[30] = 214;
   ChannelBuffer1[31] = 217;
   ChannelBuffer1[32] = 219;
   ChannelBuffer1[33] = 221;
   ChannelBuffer1[34] = 223;
   ChannelBuffer1[35] = 225;
   ChannelBuffer1[36] = 227;
   ChannelBuffer1[37] = 229;
   ChannelBuffer1[38] = 231;
   ChannelBuffer1[39] = 233;
   ChannelBuffer1[40] = 235;
   ChannelBuffer1[41] = 236;
   ChannelBuffer1[42] = 238;
   ChannelBuffer1[43] = 240;
   ChannelBuffer1[44] = 241;
   ChannelBuffer1[45] = 243;
   ChannelBuffer1[46] = 244;
   ChannelBuffer1[47] = 245;
   ChannelBuffer1[48] = 246;
   ChannelBuffer1[49] = 248;
   ChannelBuffer1[50] = 249;
   ChannelBuffer1[51] = 250;
   ChannelBuffer1[52] = 251;
   ChannelBuffer1[53] = 252;
   ChannelBuffer1[54] = 252;
   ChannelBuffer1[55] = 253;
   ChannelBuffer1[56] = 254;
   ChannelBuffer1[57] = 254;
   ChannelBuffer1[58] = 255;
   ChannelBuffer1[59] = 255;
   ChannelBuffer1[60] = 255;
   ChannelBuffer1[61] = 255;
   ChannelBuffer1[62] = 255;
   ChannelBuffer1[63] = 255;
   ChannelBuffer1[64] = 255;
   ChannelBuffer1[65] = 255;
   ChannelBuffer1[66] = 255;
   ChannelBuffer1[67] = 255;
   ChannelBuffer1[68] = 255;
   ChannelBuffer1[69] = 255;
   ChannelBuffer1[70] = 254;
   ChannelBuffer1[71] = 254;
   ChannelBuffer1[72] = 253;
   ChannelBuffer1[73] = 253;
   ChannelBuffer1[74] = 252;
   ChannelBuffer1[75] = 251;
   ChannelBuffer1[76] = 250;
   ChannelBuffer1[77] = 249;
   ChannelBuffer1[78] = 248;
   ChannelBuffer1[79] = 247;
   ChannelBuffer1[80] = 246;
   ChannelBuffer1[81] = 245;
   ChannelBuffer1[82] = 243;
   ChannelBuffer1[83] = 242;
   ChannelBuffer1[84] = 240;
   ChannelBuffer1[85] = 239;
   ChannelBuffer1[86] = 237;
   ChannelBuffer1[87] = 236;
   ChannelBuffer1[88] = 234;
   ChannelBuffer1[89] = 232;
   ChannelBuffer1[90] = 230;
   ChannelBuffer1[91] = 228;
   ChannelBuffer1[92] = 226;
   ChannelBuffer1[93] = 224;
   ChannelBuffer1[94] = 222;
   ChannelBuffer1[95] = 220;
   ChannelBuffer1[96] = 218;
   ChannelBuffer1[97] = 215;
   ChannelBuffer1[98] = 213;
   ChannelBuffer1[99] = 211;
   ChannelBuffer1[100] = 208;
   ChannelBuffer1[101] = 206;
   ChannelBuffer1[102] = 203;
   ChannelBuffer1[103] = 201;
   ChannelBuffer1[104] = 198;
   ChannelBuffer1[105] = 195;
   ChannelBuffer1[106] = 193;
   ChannelBuffer1[107] = 190;
   ChannelBuffer1[108] = 187;
   ChannelBuffer1[109] = 184;
   ChannelBuffer1[110] = 182;
   ChannelBuffer1[111] = 179;
   ChannelBuffer1[112] = 176;
   ChannelBuffer1[113] = 173;
   ChannelBuffer1[114] = 170;
   ChannelBuffer1[115] = 167;
   ChannelBuffer1[116] = 164;
   ChannelBuffer1[117] = 161;
   ChannelBuffer1[118] = 158;
   ChannelBuffer1[119] = 155;
   ChannelBuffer1[120] = 152;
   ChannelBuffer1[121] = 149;
   ChannelBuffer1[122] = 145;
   ChannelBuffer1[123] = 142;
   ChannelBuffer1[124] = 139;
   ChannelBuffer1[125] = 136;
   ChannelBuffer1[126] = 133;
   ChannelBuffer1[127] = 130;
   ChannelBuffer1[128] = 127;
   ChannelBuffer1[129] = 123;
   ChannelBuffer1[130] = 120;
   ChannelBuffer1[131] = 117;
   ChannelBuffer1[132] = 114;
   ChannelBuffer1[133] = 111;
   ChannelBuffer1[134] = 108;
   ChannelBuffer1[135] = 105;
   ChannelBuffer1[136] = 102;
   ChannelBuffer1[137] = 98;
   ChannelBuffer1[138] = 95;
   ChannelBuffer1[139] = 92;
   ChannelBuffer1[140] = 89;
   ChannelBuffer1[141] = 86;
   ChannelBuffer1[142] = 83;
   ChannelBuffer1[143] = 80;
   ChannelBuffer1[144] = 78;
   ChannelBuffer1[145] = 75;
   ChannelBuffer1[146] = 72;
   ChannelBuffer1[147] = 69;
   ChannelBuffer1[148] = 66;
   ChannelBuffer1[149] = 63;
   ChannelBuffer1[150] = 61;
   ChannelBuffer1[151] = 58;
   ChannelBuffer1[152] = 55;
   ChannelBuffer1[153] = 53;
   ChannelBuffer1[154] = 50;
   ChannelBuffer1[155] = 48;
   ChannelBuffer1[156] = 45;
   ChannelBuffer1[157] = 43;
   ChannelBuffer1[158] = 41;
   ChannelBuffer1[159] = 38;
   ChannelBuffer1[160] = 36;
   ChannelBuffer1[161] = 34;
   ChannelBuffer1[162] = 32;
   ChannelBuffer1[163] = 30;
   ChannelBuffer1[164] = 28;
   ChannelBuffer1[165] = 26;
   ChannelBuffer1[166] = 24;
   ChannelBuffer1[167] = 22;
   ChannelBuffer1[168] = 21;
   ChannelBuffer1[169] = 19;
   ChannelBuffer1[170] = 17;
   ChannelBuffer1[171] = 16;
   ChannelBuffer1[172] = 14;
   ChannelBuffer1[173] = 13;
   ChannelBuffer1[174] = 11;
   ChannelBuffer1[175] = 10;
   ChannelBuffer1[176] = 9;
   ChannelBuffer1[177] = 8;
   ChannelBuffer1[178] = 7;
   ChannelBuffer1[179] = 6;
   ChannelBuffer1[180] = 5;
   ChannelBuffer1[181] = 4;
   ChannelBuffer1[182] = 3;
   ChannelBuffer1[183] = 3;
   ChannelBuffer1[184] = 2;
   ChannelBuffer1[185] = 2;
   ChannelBuffer1[186] = 1;
   ChannelBuffer1[187] = 1;
   ChannelBuffer1[188] = 0;
   ChannelBuffer1[189] = 0;
   ChannelBuffer1[190] = 0;
   ChannelBuffer1[191] = 0;
   ChannelBuffer1[192] = 0;
   ChannelBuffer1[193] = 0;
   ChannelBuffer1[194] = 0;
   ChannelBuffer1[195] = 1;
   ChannelBuffer1[196] = 1;
   ChannelBuffer1[197] = 1;
   ChannelBuffer1[198] = 2;
   ChannelBuffer1[199] = 2;
   ChannelBuffer1[200] = 3;
   ChannelBuffer1[201] = 4;
   ChannelBuffer1[202] = 4;
   ChannelBuffer1[203] = 5;
   ChannelBuffer1[204] = 6;
   ChannelBuffer1[205] = 7;
   ChannelBuffer1[206] = 8;
   ChannelBuffer1[207] = 9;
   ChannelBuffer1[208] = 11;
   ChannelBuffer1[209] = 12;
   ChannelBuffer1[210] = 13;
   ChannelBuffer1[211] = 15;
   ChannelBuffer1[212] = 16;
   ChannelBuffer1[213] = 18;
   ChannelBuffer1[214] = 19;
   ChannelBuffer1[215] = 21;
   ChannelBuffer1[216] = 23;
   ChannelBuffer1[217] = 25;
   ChannelBuffer1[218] = 27;
   ChannelBuffer1[219] = 29;
   ChannelBuffer1[220] = 31;
   ChannelBuffer1[221] = 33;
   ChannelBuffer1[222] = 35;
   ChannelBuffer1[223] = 37;
   ChannelBuffer1[224] = 39;
   ChannelBuffer1[225] = 42;
   ChannelBuffer1[226] = 44;
   ChannelBuffer1[227] = 46;
   ChannelBuffer1[228] = 49;
   ChannelBuffer1[229] = 51;
   ChannelBuffer1[230] = 54;
   ChannelBuffer1[231] = 56;
   ChannelBuffer1[232] = 59;
   ChannelBuffer1[233] = 62;
   ChannelBuffer1[234] = 64;
   ChannelBuffer1[235] = 67;
   ChannelBuffer1[236] = 70;
   ChannelBuffer1[237] = 73;
   ChannelBuffer1[238] = 76;
   ChannelBuffer1[239] = 79;
   ChannelBuffer1[240] = 81;
   ChannelBuffer1[241] = 84;
   ChannelBuffer1[242] = 87;
   ChannelBuffer1[243] = 90;
   ChannelBuffer1[244] = 93;
   ChannelBuffer1[245] = 96;
   ChannelBuffer1[246] = 100;
   ChannelBuffer1[247] = 103;
   ChannelBuffer1[248] = 106;
   ChannelBuffer1[249] = 109;
   ChannelBuffer1[250] = 112;
   ChannelBuffer1[251] = 115;
   ChannelBuffer1[252] = 118;
   ChannelBuffer1[253] = 121;
   ChannelBuffer1[254] = 125;
   ChannelBuffer1[255] = 128;

}


unsigned char EPT_SineToolData(unsigned char index)
{
   return ChannelBuffer1[index];
}

unsigned char EPT_SineToolDelay(unsigned int delayClockTicks)
{
   unsigned int counter=0;

   while(counter < delayClockTicks)
   {
      counter += 1;
   }

   return 1;
}

